<?php
/**
 * @subpackage	plugins/content/switchinglightvideo
 * @author		isApp.it Team
 * @copyright	Copyright (C) 2011 isApp.it. All rights reserved.
 * @license		http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @link		http://www.isapp.it
 */

// no direct access
defined('_JEXEC') or die;

jimport('joomla.plugin.plugin');

class plgContentSwitchinglightvideo extends JPlugin
{
	const VERSION = '1.0.0';
	protected $nVideos = 0;
	protected $scriptAdded = false;
	protected $scriptJs = '';
	protected $turnLightJs = '/plugins/content/switchinglightvideo/js/jtol.min.js';
	protected $options = null;
	
	/**
	 * 
	 * @param	string	The context of the content being passed to the plugin.
	 * @param	object	The article object.  Note $article->text is also available
	 * @param	object	The article params
	 * @param	int		The 'page' number
	 */
	public function onContentPrepare($context, &$article, &$params, $page = 0) {
		
		/*
		 * <iframe width="560" height="315" src="http://www.youtube.com/embed/-5dU1UJvMcg" frameborder="0" allowfullscreen></iframe>
		 * */
		$playerAllow = '(youtube.com|youtube-nocookie.com|dailymotion.com|kickstarter.com|player.vimeo.com|vimeo.com)';
		$pattern = '#(<iframe(.*?)src=(.*?)'.$playerAllow.'(.*?)>(.*?)<\/iframe>|<object(.*?)(data|src)=(.*?)'.$playerAllow.'(.*?)</object>)#is';
		
		$matches = array();
		preg_match_all($pattern, $article->text, $matches, PREG_SET_ORDER);
		//die(var_dump($matches));
		
		if (empty($matches)) {
			return false;
		}
		
		if (is_null($this->options)) {
			$this->loadOptions();
		}
		
		foreach ($matches as $match) {
			$tag = 'iframe';
			if (strpos($match[0], '<iframe') !== FALSE) {
				$tag = 'iframe';
				$video = str_replace('<'.$tag.' ', '<div class="jtol_'.$this->options['switch_img'].'" id="switch_'.$this->nVideos.'"></div><'.$tag.' class="jtol_video" id="video_'.$this->nVideos.'" ', $match[0]);
			} else {
				$video = $match[0];
				if (strpos($match[0], '<object') !== FALSE) {
					$tag = 'object';
					$video = str_replace('<'.$tag.' ', '<div class="jtol_'.$this->options['switch_img'].'" id="switch_'.$this->nVideos.'"></div><'.$tag.' ', $match[0]);
				}
				if (strpos($match[0], '<embed') !== FALSE && strpos($match[0], 'vimeo.com') === FALSE) {
					$tag = 'embed';
				}
				$video = str_replace('<'.$tag.' ', '<'.$tag.' class="jtol_video" id="video_'.$this->nVideos.'" ', $video);
			}
			
			$this->setScript();
			$article->text = str_replace($match[0], $video, $article->text);
			$this->nVideos++;
		}
		
		if (!$this->scriptAdded) {
			$this->scriptAdded = true;
			if(!$this->placeScriptsJQuery()) {
				$article->text = '<script src="'.JURI::root( true ).$this->turnLightJs.'?v='.self::VERSION.'" type="text/javascript"></script>'.$article->text;
			}
		}
		$this->addScriptsJs();
	}
	
	private function loadOptions() {
		$this->options['load_jquery'] 		= $this->params->def('load_jquery', 'auto');
		$this->options['switch_img'] 		= $this->params->def('switch_img');
		$this->options['color'] 			= $this->params->def('bgcolor');
		$this->options['opacity'] 			= $this->params->def('opacity');
		$this->options['z_index'] 			= $this->params->def('z_index');
		$this->options['animation'] 		= $this->params->def('animation');
		$this->options['delay_turn_on'] 	= $this->params->def('delay_turn_on');
		$this->options['delay_turn_off']	= $this->params->def('delay_turn_off');
		$this->options['scrolling'] 		= $this->params->def('scrolling');
		$this->options['clickable_bg'] 		= $this->params->def('clickable_bg');
		$this->options['is_responsive'] 	= $this->params->def('is_responsive');
	}

	private function placeScriptsJQuery()
	{
		$document =& JFactory::getDocument();
		
		$document->addStyleSheet(JURI::root( true ).'/plugins/content/switchinglightvideo/css/switchinglightvideo.css?v='.self::VERSION);
		
		$loadjQ = true;
		
		$param_load_jquery = $this->options['load_jquery'];
		
		if ($param_load_jquery == '0') {
			$loadjQ = false;
		} elseif ($param_load_jquery == '1') {
			$loadjQ = true;
		} else {
			JLoader::import( 'joomla.version' );
			$version = new JVersion();
			if (version_compare( $version->RELEASE, '2.5', '<=')) {
				if(JFactory::getApplication()->get('jquery') !== true) {
					$header = $document->getHeadData();
					foreach($header['scripts'] as $scriptName => $scriptData) {
						if(strpos($scriptName,'/jquery') !== FALSE) {
							$loadjQ = false;
							break;
						}
					}
				}
			} else {
				JHtml::_('jquery.framework');
				$loadjQ = false;
			}
		}

		if ($loadjQ) {
			JFactory::getApplication()->set('jquery', true);
			$document->addScript( JURI::root( true ).'/plugins/content/switchinglightvideo/js/jquery-1.8.3.min.js' );
			$document->addScript( JURI::root( true ).$this->turnLightJs.'?v='.self::VERSION );
			return true;
		}
		
		return false;
	}
	
	private function setScript() {
		
		$jqOptions = $this->options;
		$jqOptions = array_filter($jqOptions, 'filter_nozero');
		$jqOptions['switch_id'] = 'switch_'.$this->nVideos;
		unset($jqOptions['load_jquery']);
		
		if (!empty($jqOptions['switch_img'])) {
			$jqOptions['switch_class'] = 'jtol_'.$jqOptions['switch_img'];
			unset($jqOptions['switch_img']);
		}
		$jsonOpt = json_encode($jqOptions);
		$jsonOpt = str_replace(array('"false"', '"true"'), array('false', 'true'), $jsonOpt);

		$this->scriptJs .= "jQuery('#video_{$this->nVideos}').allofthelights({$jsonOpt});";
	}
	
	private function addScriptsJs(){
		$document =& JFactory::getDocument();
		
		$document->addScriptDeclaration("
		jQuery(window).ready(function() {".$this->scriptJs."});");
	}
}

function filter_nozero($var) {
	return($var != '');
}
